SystemOrganization addCategory: #'Pier-CommandLink'!

PRInternalLink subclass: #PRCommandLink
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-CommandLink'!

!PRCommandLink class methodsFor: 'as yet unclassified' stamp: 'kph 8/11/2007 01:34'!
isValidReference: aString
	^ 'command:*' match: aString! !

!PRCommandLink class methodsFor: 'as yet unclassified' stamp: 'kph 8/11/2007 01:35'!
priority
	^ 20! !

!PRCommandLink methodsFor: 'as yet unclassified' stamp: 'kph 8/11/2007 13:18'!
accept: aVisitor
	 
	aVisitor visitCommandLink: self! !

!PRCommandLink methodsFor: 'as yet unclassified' stamp: 'kph 8/11/2007 13:19'!
refresh
	"This message will be sent by the structure whenever it is parsed and the references have to be set up. It simply starts a look-up in the owner using the reference-string. In case the reference is invalid the target will be set to ==nil== and the receiver is in a broken-state."

	| theClassName |
	
	theClassName := self reference copyAfterLast: $:.
 
	self target: (Smalltalk at: theClassName asSymbol ifAbsent: [ nil ])
	 ! !

!PRCommandLink methodsFor: 'as yet unclassified' stamp: 'kph 9/14/2007 03:20'!
title
	^ self target isNil
		ifTrue: [ super title ]
		ifFalse: [ self target label ]! !

!PRViewRenderer methodsFor: '*pier-commandlink-visiting-links' stamp: 'kph 8/11/2007 01:56'!
visitCommandLinkBroken: anObject
 
	html anchor
		class: 'broken';
		with: [ super visitCommandLinkBroken: anObject ]! !

!PRViewRenderer methodsFor: '*pier-commandlink-visiting-links' stamp: 'kph 8/11/2007 02:31'!
visitCommandLinkGoto: anObject
	|  context |
	
	(anObject target isValidIn: self context) ifFalse: [ ^ self ].
	 
	context := self context
		command: anObject target new.
		
 "fill in command params here?"		
	
	html anchor
		class: 'internal';
		title: anObject target shortLabel;
		goto: context;
		with: [ super visitCommandLinkGoto: anObject ]
		! !

!PRVisitor methodsFor: '*pier-commandlink-visiting-document' stamp: 'kph 8/11/2007 02:17'!
visitCommandLink: anObject
	self visitLink: anObject! !

!PRDeepRenderer methodsFor: '*pier-commandlink-visiting-links' stamp: 'kph 8/11/2007 01:52'!
visitCommandLink: anObject
	anObject isBroken
		ifTrue: [ ^ self visitCommandLinkBroken: anObject ].
	(anObject isEmbedded not or: [ self doesRemember: anObject target ])
		ifTrue: [ ^ self visitCommandLinkGoto: anObject ].
	self
		remember: anObject target
		while: [ self visitCommandLinkEmbed: anObject ]! !

!PRDeepRenderer methodsFor: '*pier-commandlink-visiting-links' stamp: 'kph 8/11/2007 01:53'!
visitCommandLinkBroken: anObject
	self visitLink: anObject! !

!PRDeepRenderer methodsFor: '*pier-commandlink-visiting-links' stamp: 'kph 8/11/2007 02:36'!
visitCommandLinkGoto: anObject
 
	anObject hasAlias
		ifTrue: [ super visitLink: anObject ]
		ifFalse: [ html render: anObject target shortLabel ]! !
